// Computergraphik I
// Prof. Dr. Juergen Doellner
// Sommersemester 2001
// 
// Rahmenprogramm fuer Aufgabenzettel 8

#ifndef CGROBOT_H
#define CGROBOT_H

#include "cgapplication.h"
#include "node.h"
#include "transformation.h"

class CGRobot : public CGApplication {
public:
    CGRobot();

    virtual void onInit();
    virtual void onDraw();
    virtual void onSize(unsigned int newWidth, unsigned int newHeight);

    virtual void onKey(unsigned char key);
    virtual void onTimer();

private:
    Node* rootNode_;

    bool pause_;
	bool constructed_;
	bool cameraBezier_;

	Camera*   camera_;
	Rotation* fingerRotation_;
	Rotation* armRotation_;
	Color*	  sensorColor_;
};

#endif // CGROBOT_H
